#define G_EXTERN extern

#include "inx-defs.h"

void malloc_error(char *program, char *function,
									char *buffer, int buffer_size)
{
	printf("%s:: Failed to allocate [%d] bytes for %s\n",
				 function, buffer_size, buffer);
	exit(0);
}


void malloc_success(char *program, char *function,
										char *buffer, int buffer_size)
{
	printf("%s:: Allocated [%d] bytes for %s\n",
				 function, buffer_size, buffer);
}


char *read_env(char env_variable[]) {
	int debugging = FALSE;

	char *return_value;
	char variable_value[1024];

	return_value = getenv(env_variable);

	if (return_value == NULL) {
		fprintf(stderr, "ERROR READING [%s]\n", env_variable);
	}
	else {
		sprintf(variable_value, "%s", getenv(env_variable));

		if (debugging) {
			fprintf(stderr, "%s = [%s]\n", env_variable, variable_value);
		}
	}

	return variable_value;
}

void set_env(char env_variable[], char env_value[]) {
	int debugging = FALSE;

	int return_value;
	char env_command[1024];

	sprintf(env_command, "%s=%s", env_variable, env_value);

	if (debugging) {
		fprintf(stderr, "putenv(%s)\n", env_command);
	}

	return_value = putenv(env_command);

	if (return_value != 0) {
		fprintf(stderr, "ERROR SETTING [%s]\n", env_command);
	}
	else {
		read_env(env_variable);
	}
}

char *input_string(int caps) {
	char ip_buffer[SMALL_BUFFER];
	int c;
	int ccount = 0;

	while ((c = getchar()) != '\n') {
		if (caps) {
			ip_buffer[ccount++] = toupper(c);
		}
		else {
			ip_buffer[ccount++] = c;
		}
	}

	ip_buffer[ccount] = '\0';

	return ip_buffer;
}

