/*
**  remove_term.c
**
**  mg - July 1996
**
**  This was a function in utilities.c
*/

#define G_EXTERN extern

#include "defs.h"


G_EXTERN void current_time(char *);
G_EXTERN void hf_header(int , char *, int );
G_EXTERN void write_termset_file(struct query_terms *, int);
G_EXTERN void malloc_error(char *, char *, char *, int);
G_EXTERN void malloc_success(char *, char *, char *, int);

void DeleteTerm(char term[]) {
  /*
	**  Modified 17 Jun 96:
	**
	**  The function 'remove_term' in gui.cc returns the source of
	**  the term to be removed. No processing needs to be done to
	**  extract the term from a string as before.
	**
	**  This function removes the term from the query by
	**  setting the field termset[].opcode to lowercase.
	*/
	
  int current_iteration;
  int current_term;
  int no_terms;
	
  char elapsed[RUNTIME_LENGTH];
	
  /*
  **  Modifying termset[] so set NEW_ITERATION = TRUE
  **
  **  The source of the term to be removed is passed from the
  **  function 'remove_term' in gui.cc
  */
	
  NEW_ITERATION = TRUE;
	
  /*
  **  If no search has been carried out ITERATION will be equal
  **  to NONE_ASSIGNED (-1). Make current_iteration = 0 if this
  **  is the case, or set it to ITERATION_NO otherwise.
  */
	
  current_iteration =
		(ITERATION_NO == NONE_ASSIGNED) ? 0 : ITERATION_NO;
	
  /*
  **  Find position of term in termset and set operation field
  **  to lowercase to retain operation information but set the
  **  display flag off (only terms with an uppercase operation
  **  field are displayed.
  */
	
  for (current_term = 0; current_term < TERM_NO; current_term++) {
    if (strcmp((termset + current_term)->source, term) == 0) {
      (termset + current_term)->operation =
				tolower((termset + current_term)->operation);
			
      /*
      **  Update ELAPSED_TIME
      */

			current_time(elapsed);
			
      hf_header(COMMAND_NO, "remove", PARAMS);
			
      fprintf(hf, ":%d:%d:%s:%c\n",
							current_iteration,
							current_term,
							term,
							(termset + current_term)->operation);
			
      break;
    }
  }
	
  write_termset_file(termset, TERM_NO);
	
  COMMAND_NO++;
}
