/*
**  remove_term.c
**
**  mg - July 1996
**
**  This was a function in utilities.c
*/

#define G_EXTERN extern

#include "defs.h"

G_EXTERN int calc_little_r(int bss_set);
G_EXTERN double calc_wgt(int np, int r, char term_type);
G_EXTERN double calc_rsv(double weight, int r, char term_type);
G_EXTERN void hf_header(int , char *, int );
G_EXTERN void current_time(char *);
G_EXTERN void malloc_error(char *, char *, char *, int);
G_EXTERN void malloc_success(char *, char *, char *, int);

void RestoreTerm(char term[])
{
  /*
  **  Created Tue 25th Jun 96 from 'remove_term.c' to enable a term
  **  double-clicked on in the 'removed terms' window to be reweighted
  **  and possibly reinstated in the current query window.
  **
  **  If it does not have a high enough RSV to appear in the top 20 it
  **  will still be removed from the removed terms window and a message
  **  explaining the situation and that it might reappear in the query
  **  after future rels will be displayed to the user.
  */

  int current_iteration;
  int current_term;
  int no_terms;

  char elapsed[RUNTIME_LENGTH];
  char temp[MAX_TERM_LENGTH];

  char removed_terms_file[FILENAME_SIZE];
  FILE *rtf;

  char removed_terms_bak_file[FILENAME_SIZE];
  FILE *rtf_bak;

  /*
  **  Modifying termset[] so set NEW_ITERATION = TRUE
  **
  **  The source of the term to be removed is passed from the
  **  function 'remove_term' in gui.cc
  */

  sprintf(removed_terms_file, "%s/%s.%d",
					Temp_dir, REMOVED_TERMS_FILE, getpid());
	
  sprintf(removed_terms_bak_file, "%s.bak", removed_terms_file);
	
  NEW_ITERATION = TRUE;
	
  /*
  **  If no search has been carried out ITERATION will be equal
  **  to NONE_ASSIGNED (-1). Make current_iteration = 0 if this
  **  is the case, or set it to ITERATION_NO otherwise.
  */
	
  current_iteration = (ITERATION_NO == NONE_ASSIGNED) ? 0 : ITERATION_NO;
	
  /*
  **  Remove term from the removed_terms_file
  **
  **  First rename removed_terms_file --> removed_terms_bak_file
  */
	
  sprintf(OS_COMMAND, "%s %s %s", MV,
					removed_terms_file, removed_terms_bak_file);
	
  if (system(OS_COMMAND) < 0) {
    perror(OS_COMMAND);
  }
	
  rtf_bak = fopen(removed_terms_bak_file, "r");
  rtf = fopen(removed_terms_file, "w");
	
  while (!feof(rtf_bak)) {
    if (fgets(temp, MAX_TERM_LENGTH, rtf_bak) == NULL) {
      break;
    }
    else {
      temp[strlen(temp) - 1] = '\0';
			
      if (strcmp(temp, term) != 0) {
				/*
				**  If they're not the same write temp to removed_terms_file
				*/
				fprintf(rtf, "%s\n", temp);
      }
    }
  }
	
  fclose(rtf_bak);
  fclose(rtf);
	
  /*
  **  Find position of term in termset and set operation field
  **  to uppercase to restore it in the termset, then calculate
  **  its current little_r, weight and rsv.
  */
	
  for (current_term = 0; current_term < TERM_NO; current_term++) {
    if (strcmp((termset + current_term)->source, term) == 0) {
      (termset + current_term)->operation =
				toupper((termset + current_term)->operation);
			
      (termset + current_term)->term_type =
				toupper((termset + current_term)->term_type);
			
      if (BIGR >= LR_THRESHOLD) {
				/*
				**  Don't need to calculate little_r - should be correct
				*/
				
				(termset + current_term)->weight =
					calc_wgt((termset + current_term)->np,
									 (termset + current_term)->little_r,
									 (termset + current_term)->term_type);
				
				(termset + current_term)->rsv =
					calc_rsv((termset + current_term)->weight,
									 (termset + current_term)->little_r,
									 (termset + current_term)->term_type);
      }
			
      /*
      **  Update ELAPSED_TIME
      */

			current_time(elapsed);
			
      hf_header(COMMAND_NO, "restore", PARAMS);
      fprintf(hf,
							":%d:%d:%s:%c\n",
							current_iteration, current_term,
							term, (termset + current_term)->operation);
      break;
    }
  }
	
  COMMAND_NO++;
	
  /*
  **  Now delete 'removed_terms_bak_file'
  */
	
  sprintf(OS_COMMAND, "%s %s", RM, removed_terms_bak_file);
	
  /*
  **  Re-read the contents of the removed_terms_file into removed_terms[]??
  */

  if (system(OS_COMMAND) < 0) {
    perror(OS_COMMAND);
  }
}


