/*Copyright (c) 2008, City University London
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and
/or other materials provided with the distribution.
    * Neither the name of the City University London nor the names of its contributors may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY D
IRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS O
F USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING N
EGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*   isdewey
     
     determines whether the portion of the string terminated
     by the first blank or end of field is a Dewey number
     ... Returns 0 if non-Dewey else the length of D.N. ...
     D.N. is nnn or nnn.nnn.....  also accepted is nnn. but a
     length of 3 is returned

 */

#include "defines.h"
#include "charclass.h"

int
isdewey(char *s, int l)  /* determines whether Dewey No within string */
{
  int i, length;
  length = 0;

  for ( i = 0; i < l; i++) {
   
    if ( tok_digit(*s) || *s == 'l' || *s == 'O' )  {
      if (length == 3) return(0); /* 4th element must be '.' */
      else {
	length++;
        s++;
      }
    }
    else {
           if ( length >  4 && *s == ' ') /* space terminating DN */
	     return(length);
      else if ( length == 4 && *s == ' ') /* nnn. taken as nnn */
	     return(--length);
      else if ( length < 3 )	/* min length of DN is 3 */
             return(0) ;
      else if (length == 3 && *s == '.') { /* 4th element of DN is . */
	     length++;
	     s++;
      }
      else if (length == 3 && *s == ' ')
	     return(length);
      else
	     return(0);		/* not DN */
    }
  }
  return((length>=3) ? length : 0);
}
