/*Copyright (c) 2008, City University London
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and
/or other materials provided with the distribution.
    * Neither the name of the City University London nor the names of its contributors may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY D
IRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS O
F USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING N
EGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/******************************************************************************

  mergeonly.c SW May 93

  Prog to do single merge pass on an acceptable number of Okapi index
  runfiles.

******************************************************************************/

#include "defines.h"

BOOL silent =  FALSE ;
u_int Secs ;
OFFSET_TYPE merge(int, int num, int outsuffix, char *, char *, BOOL, int itype,
	  int delete) ;

int
main(int argc, char *argv[])
{
  int itype ;
  int numfiles ;
  int firstsuff ;
  char *infile_stem ;
  OFFSET_TYPE result ;

  static char *usage = 
 "Usage: %s infile_stem firstsuff num index_type\n\
E.g. /vol/ok.1/ix1_ex.1109. 23 12 4\n\
Writes output to stdout.\n" ;

  if ( argc != 5 ) {
    fprintf(stderr, usage, argv[0]) ;
    exit(1) ;
  }

  infile_stem=argv[1] ;
  firstsuff=atoi(argv[2]) ;
  numfiles=atoi(argv[3]) ;
  itype=atoi(argv[4]) ;
		 

  result = 
     merge(firstsuff, numfiles, 9999, infile_stem, "rubbish", 1, itype, 0) ;
  if ( result < 0 ) exit(1) ;
  else exit(0) ;

}


