/*Copyright (c) 2008, City University London
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and
/or other materials provided with the distribution.
    * Neither the name of the City University London nor the names of its contributors may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY D
IRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS O
F USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING N
EGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "win32extras.h"

int gettimeofday(struct timeval *tp, void *tz)
{
	time_t			ltime;
	struct _timeb	tstruct;
    
	time(&ltime);							// Determine the system time (Since UTC 1/1/70)	
	_ftime(&tstruct);						// Populate tstruct to obtain milliseconds

	tp->tv_sec = ltime;						// Note : tstruct.millitm is divided by 1000 to give microseconds
	tp->tv_usec = tstruct.millitm * 1000;

	return 0;
}

pid_t getpid(void)
{
	return (pid_t)GetCurrentProcessId();
}

uid_t getuid(void)
{
	return 0;
}

gid_t getgid(void)
{
	return 0;
}

int getgroups(int gidsetsize, gid_t *grouplist)
{
	return 0;
}

char *cuserid(char *s)
{
	DWORD	dwBufSize = 32;
	char	szBuffer[32];

	if (GetUserName(szBuffer, &dwBufSize))
	{
		strcpy(s, szBuffer);
	}

	return 0;
}

int ftruncate(int fildes, off_t length)
{
	return 0;
}

BYTE* GetSetting(LPCSTR strSettingName)
{
	LONG	Result			= 0;
	HKEY	hKey			= 0;
	DWORD	dwBuffSize		= 0;
	BYTE	*szBuffer		= NULL;
	
	// Open the registry path for BSS
	
	if((Result = RegOpenKeyEx(BSS_REG_BASE_KEY, BSS_REG_PATH, 0, KEY_QUERY_VALUE, &hKey)) == ERROR_SUCCESS)	
	{
		if((Result = RegQueryValueEx(hKey, strSettingName, NULL, NULL, NULL, &dwBuffSize)) == ERROR_SUCCESS)
		{
			// Allocate the memory to hold the data
		
			szBuffer = (BYTE*)malloc((size_t)dwBuffSize);
			
			// Read the data into the buffer

			RegQueryValueEx(hKey, strSettingName, NULL, NULL, szBuffer, &dwBuffSize);			
		}

		RegCloseKey(hKey);
	}

	return szBuffer;
}
